VSTGUI: VSTGUI::Standalone::Value Namespace Reference

VSTGUI 4.10 Graphical User Interface Framework not only for VST plugins

Loading...
Searching...
No Matches
Namespaces | Classes
VSTGUI::Standalone::Value Namespace Reference
Standalone Library

value create and helper functions More...

## Namespaces
namespace | Detail

## Classes
class | Listener
| Value listener More...
class | ListenerT
| Value listener More...

## Functions
Create values
ValuePtr | make (const UTF8String &id, IValue::Type initialValue=0., const ValueConverterPtr &valueConverter=nullptr)
| make a value in the normalized range [0..1]
ValuePtr | makeStepValue (const UTF8String &id, IStepValue::StepType numSteps, IValue::Type initialValue=0., const ValueConverterPtr &valueConverter=nullptr)
| make a step value
ValuePtr | makeStringListValue (const UTF8String &id, const std::initializer_list< IStringListValue::StringType > &strings, IValue::Type initialValue=0.)
| make a string list value
ValuePtr | makeStringListValue (const UTF8String &id, const IStringListValue::StringList &strings)
| make a string list value
ValuePtr | makeStaticStringValue (const UTF8String &id, const UTF8String &value)
| make a static string value
ValuePtr | makeStaticStringValue (const UTF8String &id, UTF8String &&value)
| make a static string value
ValuePtr | makeStringValue (const UTF8String &id, const UTF8String &initialString)
| make a string value
ValuePtr | makeStringValue (const UTF8String &id, UTF8String &&initialString)
| make a string value
Create value converters
ValueConverterPtr | makePercentConverter ()
| make a percent value converter
ValueConverterPtr | makeRangeConverter (IValue::Type minValue, IValue::Type maxValue, uint32_t stringPrecision=4)
| make a range value converter
Value helper functions
IValue::Type | plainToNormalize (IValue &value, IValue::Type plainValue)
IValue::Type | normalizeToPlain (IValue &value, IValue::Type normalizeValue)
IValue::Type | stepToNormalize (IValue &value, IStepValue::StepType stepValue)
IStepValue::StepType | normalizeToStep (IValue &value, IValue::Type normalizeValue)
IValue::Type | currentPlainValue (IValue &value)
IStepValue::StepType | currentStepValue (IValue &value)
UTF8String | currentStringValue (IValue &value)
void | performSingleEdit (IValue &value, IValue::Type newValue)
void | performSinglePlainEdit (IValue &value, IValue::Type plainValue)
bool | performSingleStepEdit (IValue &value, IStepValue::StepType step)
bool | performStringValueEdit (IValue &value, const UTF8String &str)
bool | performStringAppendValueEdit (IValue &value, const UTF8String &str)

## Detailed Description

value create and helper functions

## Function Documentation

## ◆ currentPlainValue()

IValue::Type currentPlainValue | ( | IValue & | value | ) |
| inline

## ◆ currentStepValue()

IStepValue::StepType currentStepValue | ( | IValue & | value | ) |
| inline

## ◆ currentStringValue()

UTF8String currentStringValue | ( | IValue & | value | ) |
| inline

## ◆ make()

ValuePtr make | ( | const UTF8String & | id,
|  | IValue::Type | initialValue = 0.,
|  | const ValueConverterPtr & | valueConverter = nullptr )

make a value in the normalized range [0..1]

Parameters

  id | value ID
  initialValue | initial value
  valueConverter | value converter

Returns
  shared value pointer

## ◆ makePercentConverter()

ValueConverterPtr makePercentConverter | ( |  | ) |

make a percent value converter

converts normalized values to the range [0..100]

## ◆ makeRangeConverter()

ValueConverterPtr makeRangeConverter | ( | IValue::Type | minValue,
|  | IValue::Type | maxValue,
|  | uint32_t | stringPrecision = 4 )

make a range value converter

converts normalized values to the range [minValue..maxValue]

## ◆ makeStaticStringValue() [1/2]

ValuePtr makeStaticStringValue | ( | const UTF8String & | id,
|  | const UTF8String & | value )

make a static string value

a static string value is an inactive unchangeable value

Parameters

  id | value ID
  value | static string

Returns
  shared value pointer

## ◆ makeStaticStringValue() [2/2]

ValuePtr makeStaticStringValue | ( | const UTF8String & | id,
|  | UTF8String && | value )

make a static string value

a static string value is an inactive unchangeable value

Parameters

  id | value ID
  value | static string

Returns
  shared value pointer

## ◆ makeStepValue()

ValuePtr makeStepValue | ( | const UTF8String & | id,
|  | IStepValue::StepType | numSteps,
|  | IValue::Type | initialValue = 0.,
|  | const ValueConverterPtr & | valueConverter = nullptr )

make a step value

Parameters

  id | value ID
  numSteps | number of discrete steps, must be greater than zero
  initialValue | initial value in the normalized range [0..1]
  valueConverter | value converter

Returns
  shared value pointer

## ◆ makeStringListValue() [1/2]

ValuePtr makeStringListValue | ( | const UTF8String & | id,
|  | const IStringListValue::StringList & | strings )

make a string list value

the returned value object has the IStringListValue interface

Parameters

  id | value ID
  strings | string list

Returns
  shared value pointer

## ◆ makeStringListValue() [2/2]

ValuePtr makeStringListValue | ( | const UTF8String & | id,
|  | const std::initializer_list< IStringListValue::StringType > & | strings,
|  | IValue::Type | initialValue = 0. )

make a string list value

a string list value is a step value where each step has a string representation.

to modify the string list you can cast the returned value object to IStringListValue and use the updateStringList method.

Parameters

  id | value ID
  strings | string list
  initialValue | initial value in the normalized range [0..1]

Returns
  shared value pointer

## ◆ makeStringValue() [1/2]

ValuePtr makeStringValue | ( | const UTF8String & | id,
|  | const UTF8String & | initialString )

make a string value

a string value has always the same numerical but different string representations

Parameters

  id | value ID
  value | initial string

Returns
  shared value pointer

## ◆ makeStringValue() [2/2]

ValuePtr makeStringValue | ( | const UTF8String & | id,
|  | UTF8String && | initialString )

make a string value

a string value has always the same numerical but different string representations

Parameters

  id | value ID
  value | initial string

Returns
  shared value pointer

## ◆ normalizeToPlain()

IValue::Type normalizeToPlain | ( | IValue & | value,
|  | IValue::Type | normalizeValue )
| inline

## ◆ normalizeToStep()

IStepValue::StepType normalizeToStep | ( | IValue & | value,
|  | IValue::Type | normalizeValue )
| inline

## ◆ performSingleEdit()

void performSingleEdit | ( | IValue & | value,
|  | IValue::Type | newValue )
| inline

## ◆ performSinglePlainEdit()

void performSinglePlainEdit | ( | IValue & | value,
|  | IValue::Type | plainValue )
| inline

## ◆ performSingleStepEdit()

bool performSingleStepEdit | ( | IValue & | value,
|  | IStepValue::StepType | step )
| inline

## ◆ performStringAppendValueEdit()

bool performStringAppendValueEdit | ( | IValue & | value,
|  | const UTF8String & | str )
| inline

## ◆ performStringValueEdit()

bool performStringValueEdit | ( | IValue & | value,
|  | const UTF8String & | str )
| inline

## ◆ plainToNormalize()

IValue::Type plainToNormalize | ( | IValue & | value,
|  | IValue::Type | plainValue )
| inline

## ◆ stepToNormalize()

IValue::Type stepToNormalize | ( | IValue & | value,
|  | IStepValue::StepType | stepValue )
| inline